## aacgain 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(aacgain VERSION 2.0.0)

add_subdirectory(3rdparty)

add_definitions(-DHAVE_CONFIG_H -DAACGAIN)

include(CheckIncludeFile)
include(CheckIncludeFiles)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
check_include_file("stdint.h" HAVE_STDINT_H)
check_include_files("stdlib.h;stdarg.h;string.h;float.h" STDC_HEADERS)

configure_file("${PROJECT_SOURCE_DIR}/config.h.in"
               "${PROJECT_BINARY_DIR}/config.h"
              )
include_directories("${PROJECT_BINARY_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/aacgain")

add_subdirectory(mp3gain)
add_subdirectory(aacgain)

=== 3rdparty/CMakeLists.txt ===
include(ExternalProject)

IF(UNIX)
include(ProcessorCount)
ProcessorCount(N)

ExternalProject_Add(faad2_proj
                    SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/faad2"
                    CONFIGURE_COMMAND autoreconf -i && ./configure --prefix=${CMAKE_CURRENT_BINARY_DIR} --disable-shared --enable-static
                    BUILD_COMMAND make -j ${N}
                    INSTALL_COMMAND make -j ${N} install
                    BUILD_IN_SOURCE 1
                   )

ExternalProject_Add(mp4v2_proj
                    SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mp4v2"
                    CONFIGURE_COMMAND autoreconf -i && ./configure --prefix=${CMAKE_CURRENT_BINARY_DIR} --disable-shared --enable-static
                    BUILD_COMMAND make -j ${N}
                    INSTALL_COMMAND make -j ${N} install
                    BUILD_IN_SOURCE 1
                   )

set(PREFIX_CLEAN_DIRS bin include lib share)
set_directory_properties(PROPERTIES ADDITIONAL_CLEAN_FILES "${PREFIX_CLEAN_DIRS}")
ENDIF(UNIX)

IF(WIN32)
ExternalProject_Add(faad2_proj
	SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/faad2"
		    CONFIGURE_COMMAND ""
		    BUILD_COMMAND msbuild project/msvc/faad2.sln -t:libfaad -p:Configuration=Release -p:Platform=x64 -maxcpucount
		    INSTALL_COMMAND ""
		    BUILD_IN_SOURCE 1
		   )
ExternalProject_Add(mp4v2_proj
		    SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mp4v2"
		    CONFIGURE_COMMAND ""
		    BUILD_COMMAND msbuild mp4v2-Win/mp4v2.sln -t:libmp4v2 -p:Configuration=Release -p:Platform=x64 -maxcpucount
		    INSTALL_COMMAND ""
		    BUILD_IN_SOURCE 1
		   )
ENDIF(WIN32)

add_library(faad2 STATIC IMPORTED GLOBAL)
add_library(mp4v2 STATIC IMPORTED GLOBAL)

IF(UNIX)
set(FAAD_LIB_PATH "${CMAKE_CURRENT_BINARY_DIR}/lib/libfaad.a")
set(MP4V2_LIB_PATH "${CMAKE_CURRENT_BINARY_DIR}/lib/libmp4v2.a")
ENDIF(UNIX)

if(WIN32)
set(FAAD_LIB_PATH "${PROJECT_SOURCE_DIR}/3rdparty/faad2/project/msvc/x64/Release/libfaad.lib")
set(MP4V2_LIB_PATH "${PROJECT_SOURCE_DIR}/3rdparty/mp4v2/mp4v2-Win/bin/x64/Release/libmp4v2.lib")
ENDIF(WIN32)

set_target_properties(faad2 PROPERTIES IMPORTED_LOCATION "${FAAD_LIB_PATH}")
set_target_properties(mp4v2 PROPERTIES IMPORTED_LOCATION "${MP4V2_LIB_PATH}")

=== aacgain/CMakeLists.txt ===
add_executable(aacgain
               aacgain.cpp decoder.c syntax.c MP4MetaFile.cpp)

target_include_directories(aacgain PRIVATE
# Is there a better way to do this than PROJECT_SOURCE_DIR
                           "${CMAKE_CURRENT_SOURCE_DIR}"
                           "${PROJECT_SOURCE_DIR}/mp3gain"
                           "${PROJECT_SOURCE_DIR}/aacgain"
			   "${PROJECT_BINARY_DIR}/3rdparty/include"
                           "${PROJECT_SOURCE_DIR}/3rdparty/mp4v2"
                           "${PROJECT_SOURCE_DIR}/3rdparty/faad2/libfaad"
# These two exist on UNIX but paths are needed on Windows
# as we have no install targets for Windows
                           "${PROJECT_SOURCE_DIR}/3rdparty/mp4v2/src"
                           "${PROJECT_SOURCE_DIR}/3rdparty/mp4v2/include"
                           "${PROJECT_SOURCE_DIR}/3rdparty/faad2/include"
			   "${PROJECT_BINARY_DIR}/aacgain"
                          )
target_link_libraries(aacgain PRIVATE
                      mp3gain
                      mpglib
                      faad2
                      mp4v2
                     )
add_dependencies(aacgain faad2_proj mp4v2_proj)
IF(UNIX)
target_compile_options(aacgain PRIVATE -Wall -Wextra)
ENDIF(UNIX)
install(TARGETS aacgain DESTINATION bin)

=== mp3gain/CMakeLists.txt ===
add_subdirectory(mpglibDBL)

add_library(mp3gain
            STATIC
            mp3gain.c gain_analysis.c apetag.c id3tag.c rg_error.c
            )
target_include_directories(mp3gain PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}")
target_link_libraries(mp3gain mpglib)
IF(UNIX)
target_compile_options(mp3gain PRIVATE -Wall -Wextra)
ENDIF(UNIX)

=== mp3gain/mpglibDBL/CMakeLists.txt ===
add_library(mpglib
           STATIC
           bitstream.h common.c common.h dct64_i386.c
           dct64_i386.h decode_i386.c decode_i386.h encoder.h huffman.h interface.c
           interface.h l2tables.h lame-analysis.h lame.h layer1.c layer1.h layer2.c
           layer2.h layer3.c layer3.h machine.h mpg123.h mpglib.h tabinit.c
           tabinit.h VbrTag.h
           )
IF(UNIX)
target_compile_options(mpglib PRIVATE -Wall -Wextra)
ENDIF(UNIX)

## aacgain 1.9

=== debian/changelog ===
aacgain (1.9-5~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Drop dmo branding.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 06 Jun 2023 16:15:04 -0700

aacgain-dmo (1.9-dmo5) unstable; urgency=medium

  * Revorke source to build with recent gcc.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 20 Apr 2021 14:26:02 +0200

aacgain (1.9-dmo4) unstable; urgency=medium

  * Fix build with GCC 7

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 02 Dec 2017 19:07:29 +0100

aacgain (1.9-dmo3) unstable; urgency=medium

  * Rebuild with PIE

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 06 Mar 2017 01:10:03 +0100

aacgain (1.9-dmo2) unstable; urgency=medium

  * Build with GCC 5.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 02 Aug 2015 15:33:47 +0200

aacgain (1.9-dmo1) unstable; urgency=low

  * Build with hardened flags.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 20 Jun 2012 16:34:03 +0200

aacgain (1.9-0.2) unstable; urgency=low

  * Fix build with -j make option.

 -- Christian Marillat <marillat@debian.org>  Tue, 10 Jan 2012 17:01:43 +0100

aacgain (1.9-0.1) unstable; urgency=low

  * Build mp4v2 with --disable-optimize for armhf.

 -- Christian Marillat <marillat@debian.org>  Tue, 10 Jan 2012 14:20:17 +0100

aacgain (1.9-0.0) unstable; urgency=low

  * New upstream release.

 -- Christian Marillat <marillat@debian.org>  Thu, 05 Aug 2010 11:33:31 +0200

aacgain (1.8-0.1) unstable; urgency=low

  * Fix build by removing wrong strcasestr() declaration.
  * Added support for ccache.

 -- Christian Marillat <marillat@debian.org>  Wed, 24 Feb 2010 11:48:54 +0100

aacgain (1.8-0.0) unstable; urgency=low

  * New upstream release.

 -- Christian Marillat <marillat@debian.org>  Mon, 22 Jun 2009 12:00:29 +0200

aacgain (1.7-0.0) unstable; urgency=low

  * Initial release.

 -- Christian Marillat <marillat@debian.org>  Tue, 06 Nov 2007 16:01:15 +0100

=== debian/control ===
Source: aacgain
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://aacgain.altosdesign.com/
Standards-Version: 4.5.1
Build-Depends: debhelper-compat (= 13)

Package: aacgain
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Lossless mp4 normalizer with statistical analysis
 AACGain normalizes the volume of digital music files using the Replay Gain
 algorithm. It works by modifying the global_gain fields in the mp4 samples.
 Free-form metadata tags are added to the file to save undo information,
 making the normalization process reversable. It supports AAC
 (mp4/m4a/QuickTime) audio files in addition to mp3 files.
 .
 AACGain uses the same command-line user interface as mp3gain

=== debian/rules ===
#!/usr/bin/make -f

ifeq "$(DEB_BUILD_ARCH)" "armhf"
	OPTIONS=--disable-optimize
endif


ifneq (,$(findstring parallel=,$(DEB_BUILD_OPTIONS)))
	NCPUS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
	NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
	ifeq ($(NCPUS),-1)
		NCPUS:=1
	endif
	ifeq ($(NCPUS),0)
		NCPUS:=1
	endif
endif

export DEB_CXXFLAGS_MAINT_APPEND = -fpermissive -Wno-narrowing

%:
	dh $@

override_dh_auto_configure:
	cd mp4v2 && ./configure $(CROSS) CFLAGS="$(CFLAGS)" $(OPTIONS) --disable-gch
	cd faad2 && ./configure $(CROSS) CFLAGS="$(CFLAGS)" --without-xmms --without-mpeg4ip

	dh_auto_configure

override_dh_auto_build:
	$(MAKE) -C mp4v2 -j $(NCPUS)
	$(MAKE) -C faad2 -j $(NCPUS)

	$(MAKE) -j $(NCPUS)

override_dh_clean:
	if [ -f mp4v2/GNUmakefile ] ; then cd mp4v2 && $(MAKE) distclean ; fi
	if [ -f faad2/Makefile ] ; then cd faad2 && $(MAKE) distclean ; fi
	dh_clean aacgain/config.h mpeg4ip_config.h faad2/config.h mpeg4ip_config.h

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=3

#opts="uversionmangle=s/_/./" \
#http://www.rarewares.org/files/aac/ aacgain_(.*)\.zip

## aacgain 2.0.0

=== debian/changelog ===
aacgain (2.0.0-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Remove dmo branding in versions.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 06 Jun 2023 15:36:56 -0700

aacgain-dmo (2.0.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 03 Mar 2023 09:40:48 +0100

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
-Homepage: https://aacgain.altosdesign.com/
-Standards-Version: 4.5.1
-Build-Depends: debhelper-compat (= 13)
+Homepage: https://github.com/dgilman/aacgain
+Standards-Version: 4.6.2
+Build-Depends: cmake, debhelper-compat (= 12)
 
 Package: aacgain
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

#ifeq "$(DEB_BUILD_ARCH)" "armhf"
#	OPTIONS=--disable-optimize
#endif

#export DEB_CXXFLAGS_MAINT_APPEND = -fpermissive -Wno-narrowing
export UNIX=1

# external git
# https://github.com/dgilman/mp4v2/tree/cf634bb7ed2d3bd453d707a5c7896dcd6f12e458
# https://github.com/dgilman/faad2/tree/a65ecabd13a6b991781d75856e1b6870ce00fc70

%:
	dh $@ -Scmake

override_dh_clean:
	if [ -f 3rdparty/mp4v2/GNUmakefile ] ; then cd 3rdparty/mp4v2 && $(MAKE) distclean ; fi
	if [ -f 3rdparty/faad2/Makefile ] ; then cd 3rdparty/faad2 && $(MAKE) distclean ; fi

	dh_clean aacgain/config.h mpeg4ip_config.h faad2/config.h mpeg4ip_config.h

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=4

https://github.com/dgilman/aacgain/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@
